#pragma once

#include "ActorInterface.h"
#include "WASCommand.h"
#include "WASActor.h"

class CWASUpdateBuddy : public CWASCommand
{
public:
	CWASUpdateBuddy(CWASActor *pActor);
	~CWASUpdateBuddy(void);

	void ExecuteAsync(void);

	void SetParameter(vector< pair<wstring, int> > vecBuddy, int nNewGrpID)
	{
		m_vecBuddy = vecBuddy;
		m_nNewGrpID = nNewGrpID;
	}


private:
	bool ParseAndEventFire(nfc::CIkXMLDom * pDom);

protected:
	// override in drived class
	virtual void OnWasResponse(trid_t /*trid*/, bool /*bSuccess*/, int /*nWinINetErrorCode*/, int /*nHttpResponseCode*/, 
		LPCSTR /*szWasResCodeInHeader*/, 
		LPCSTR /*szWasResCodeInXml*/,
		nfc::CIkXMLDom * /*pDom*/);

	virtual void OnRequestTimeout(CHttpFacade * /*pHttpF*/, DWORD /*dwSeconds*/);

private:

	vector< pair<wstring, int> > m_vecBuddy;
	int m_nNewGrpID;
};
